﻿using Newtonsoft.Json;

namespace AsmrManage
{
    public class AppConfig //应用配置
    {
        public string DatabaseFilePath { get; set; } = string.Empty; //asmr.db 位置
        public string DBBrowserPath { get; set; } = string.Empty; //DBBrowser 位置
        public int Version { get; set; } = int.MaxValue; //配置版本信息
    }
    public static class ConfigManager
    {
        public static void SaveConfig(AppConfig config) //SAVE
        {
            config.Version = 1;// v1
            string configFilePath = Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "config.json");
            File.WriteAllText(configFilePath, JsonConvert.SerializeObject(config));
        }

        public static AppConfig LoadConfig() //LOAD
        {
            string configFilePath = Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "config.json");

            if (File.Exists(configFilePath))
            {
                string json = File.ReadAllText(configFilePath);
                return JsonConvert.DeserializeObject<AppConfig>(json) ?? new AppConfig();
            }

            return new AppConfig();
        }
    }

}
