using DiffPlex.DiffBuilder.Model;
using DiffPlex.DiffBuilder;
using OfficeOpenXml;
using System.Data.SQLite;
using System.Diagnostics;
using System.Text.RegularExpressions;

namespace AsmrManage
{
    public partial class Form1 : Form
    {
        public Form1() //init
        {
            InitializeComponent();
        }


        private void Button1_Click(object sender, EventArgs e) //P2 xlsxļѡ
        {
            OpenFileDialog openFileDialog1 = new OpenFileDialog();
            openFileDialog1.Title = "ѡϵxlsxļ";
            openFileDialog1.InitialDirectory = Environment.GetFolderPath(Environment.SpecialFolder.Desktop);
            openFileDialog1.Filter = "Excelļ|*.xlsx|ļ|*.*";
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                textBox1.Text = openFileDialog1.FileName;
            }

        }

        private void Button2_Click(object sender, EventArgs e) //P2 dbļλѡ
        {
            FolderBrowserDialog folderBrowserDialog1 = new FolderBrowserDialog();
            folderBrowserDialog1.UseDescriptionForTitle = true;
            folderBrowserDialog1.Description = "ѡ񱣴λ";
            if (folderBrowserDialog1.ShowDialog() == DialogResult.OK)
            {
                textBox2.Text = folderBrowserDialog1.SelectedPath;
            }
        }

        private void Log(string message) //xlsx2db log function
        {
            logBox1.AppendText(message + Environment.NewLine);
            logBox1.ScrollToCaret();
        }

        private void Button3_Click(object sender, EventArgs e) //xlsx2db ʼ
        {
            Log("ʼ");
            string excelFilePath = textBox1.Text;
            string? databaseLocation;
            if (checkBox2.Checked)
            {
                databaseLocation = Path.GetDirectoryName(excelFilePath);
            }
            else
            {
                databaseLocation = textBox2.Text;
            }

            if (string.IsNullOrEmpty(excelFilePath) || string.IsNullOrEmpty(databaseLocation))
            {
                Log("TextBox1  TextBox2 Ϊգ޷");
                return;
            }
            string databaseFileName = "asmr.db";
            string databasePath = Path.Combine(databaseLocation, databaseFileName);
            Log($"Դļ:{excelFilePath}\nļ:{databasePath}");
            FileInfo fileInfo = new FileInfo(excelFilePath);

            string? password = null;

            if (checkBox4.Checked)// ļ뱣
            {
                Log("ļ뱣");
                password = textBox3.Text;
            }

            if (!File.Exists(databasePath))
            {
                Log("ĿDBļڣ׼");
                SQLiteConnection.CreateFile(databasePath);
            }
            else
            {
                if (checkBox1.Checked) //allow override
                {
                    Log("ļѴڣ15s󸲸Ѵڵļ練뼰ʱ");
                    Task.Delay(15000).Wait(); // ʱ15
                    File.Delete(databasePath);
                    SQLiteConnection.CreateFile(databasePath);
                }
                else
                {
                    Log("ļѴڣǰ趨ļ˳");
                    return;
                }
            }

            string connectionString = $"Data Source={databasePath};Version=3;";

            Task.Run(() =>
            {
                try
                {
                    using (ExcelPackage package = new ExcelPackage(fileInfo, password))
                    {
                        using (SQLiteConnection connection = new SQLiteConnection(connectionString))
                        {
                            connection.Open();

                            foreach (var worksheet in package.Workbook.Worksheets)
                            {
                                string tableName = worksheet.Name;
                                BeginInvoke((Action)(() =>
                                {
                                    Log($"ʼ{tableName}");
                                }));


                                // һ洢
                                string createTableQuery = $"CREATE TABLE IF NOT EXISTS {tableName} (asmr_id TEXT, asmr_order_id INTEGER)";
                                using (SQLiteCommand command = new SQLiteCommand(createTableQuery, connection))
                                {
                                    command.ExecuteNonQuery();
                                }

                                int rowCount = worksheet.Dimension.Rows;

                                for (int row = 2; row <= rowCount; row++) // ӵڶпʼһǱͷ
                                {
                                    string? asmr_id = worksheet.Cells[row, 1].Value?.ToString();
                                    int asmr_order_id = Convert.ToInt32(worksheet.Cells[row, 2].Value);

                                    string insertDataQuery = $"INSERT INTO {tableName} (asmr_id, asmr_order_id) VALUES (@asmr_id, @asmr_order_id)";

                                    using (SQLiteCommand insertCommand = new SQLiteCommand(insertDataQuery, connection))
                                    {
                                        insertCommand.Parameters.AddWithValue("@asmr_id", asmr_id);
                                        insertCommand.Parameters.AddWithValue("@asmr_order_id", asmr_order_id);

                                        insertCommand.ExecuteNonQuery();
                                    }
                                }
                            }
                        }
                    }
                }
                catch (Exception ex)
                {
                    BeginInvoke((Action)(() =>
                    {
                        Log($"ERROR: {ex}");
                    }));
                    return;
                }
                BeginInvoke((Action)(() =>
                {
                    Log("SUCCESS");
                }));
                if (checkBox3.Checked)
                {
                    Process.Start("explorer.exe", databaseLocation);
                }
            });
        }
        private void CheckBox2_CheckedChanged(object sender, EventArgs e) //תʹԴļλ
        {
            textBox2.Enabled = !checkBox2.Checked;
            button2.Enabled = !checkBox2.Checked;
        }
        private void CheckBox4_CheckedChanged(object sender, EventArgs e) //ļǷ뱣
        {
            textBox3.ReadOnly = !checkBox4.Checked;
        }

        private void TabControl1_SelectedIndexChanged(object sender, EventArgs e) //лǩҳ
        {
            ResetPage1();
            ResetPage2();
            ResetPage3();
            ResetPage4();
            if (tabControl1.SelectedTab == tabPage4)
            {
                RefreshSettingPageInfo();
            }
        }

        private void RefreshSettingPageInfo()  //»ȡP4Ϣ
        {
            Program.config ??= ConfigManager.LoadConfig();
            textBox4.Text = Program.config.DatabaseFilePath;
            textBox5.Text = Program.config.DBBrowserPath;
        }

        private void ResetPage4()
        {
            textBox4.Text = string.Empty;
            textBox5.Text = string.Empty;
        } //ˢP4
        private void ResetPage3() //ˢP3
        {
            textBox7.Text = string.Empty;
            label18.Text = string.Empty;
            label19.Text = string.Empty;
            label20.Text = string.Empty;
            label21.Text = string.Empty;
            label26.Text = string.Empty;
            label27.Text = string.Empty;
            label28.Text = string.Empty;
            label29.Text = string.Empty;
            checkBox9.Checked = false;
            checkBox10.Checked = false;
            checkBox11.Checked = false;
            checkBox12.Checked = false;
            richTextBox2.Text = string.Empty;
        }

        private void ResetPage2()
        {
            // 
            textBox1.Text = string.Empty;
            textBox2.Text = string.Empty;
            textBox3.Text = string.Empty;
            logBox1.Text = string.Empty;

            // ȡѡcheckBox1~4
            checkBox1.Checked = false;
            checkBox2.Checked = false;
            checkBox3.Checked = false;
            checkBox4.Checked = false;
        } //ˢP2

        private void ResetPage1() //ˢP1
        {
            textBox6.Text = string.Empty;
            comboBox1.SelectedItem = null;
            label12.Text = string.Empty;
            checkBox5.Checked = false;
            checkBox6.Checked = false;
            checkBox7.Checked = false;
            checkBox8.Checked = false;
            richTextBox1.Text = string.Empty;
            button13.Enabled = false;
        }

        private void Button7_Click(object sender, EventArgs e) //ȡļ
        {
            Program.config = ConfigManager.LoadConfig();
            RefreshSettingPageInfo();
            MessageBox.Show("Ϣ¼ء", "ʾ", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        private void button8_Click(object sender, EventArgs e) //ļ
        {
            //ǰϢ
            string path1 = textBox4.Text.Trim();
            string path2 = textBox5.Text.Trim();
            if (!string.IsNullOrEmpty(path1) && !File.Exists(path1))
            {
                MessageBox.Show("ָDB·ڡ·Ƿȷ", "", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            if (!string.IsNullOrEmpty(path2) && !File.Exists(path2))
            {
                MessageBox.Show("ָDB Browser·ڡ·Ƿȷ", "", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }

            //ʼ
            Program.config ??= ConfigManager.LoadConfig();
            Program.config.DatabaseFilePath = path1;
            Program.config.DBBrowserPath = path2;
            ConfigManager.SaveConfig(Program.config);
        }

        private void button9_Click(object sender, EventArgs e) //ļ
        {
            Program.config = null;
            ConfigManager.SaveConfig(new AppConfig());
            RefreshSettingPageInfo();
        }

        private void button4_Click(object sender, EventArgs e) //P4 ļѡ1
        {
            OpenFileDialog openFileDialog1 = new OpenFileDialog();
            openFileDialog1.Title = "ѡȷdbݿļ";
            openFileDialog1.InitialDirectory = Environment.GetFolderPath(Environment.SpecialFolder.Desktop);
            openFileDialog1.Filter = "sqlite dbļ|asmr.db";
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                textBox4.Text = openFileDialog1.FileName;
            }
        }

        private void button5_Click(object sender, EventArgs e) //p4 EXEļλѡ2
        {
            OpenFileDialog openFileDialog1 = new OpenFileDialog();
            openFileDialog1.Title = "ѡDB Browser for SQLite";
            openFileDialog1.InitialDirectory = Environment.GetFolderPath(Environment.SpecialFolder.Desktop);
            openFileDialog1.Filter = "DB Browser for SQLite|DB Browser for SQLite.exe";
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                textBox5.Text = openFileDialog1.FileName;
            }
        }

        private void button6_Click(object sender, EventArgs e) //p4 db browserԤݿ
        {
            if (Program.config == null) { Program.config = ConfigManager.LoadConfig(); }
            string db_path = Program.config.DatabaseFilePath;
            string dbb_path = Program.config.DBBrowserPath;
            //·Ƿ
            if (File.Exists(db_path) && File.Exists(dbb_path))
            {
                ProcessStartInfo psi = new ProcessStartInfo
                {
                    FileName = dbb_path,
                    Arguments = db_path
                };

                try
                {
                    Process.Start(psi);
                }
                catch (Exception ex)
                {
                    MessageBox.Show("" + ex.Message, "", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
            else
            {
                MessageBox.Show("ָ·ڡ·Ƿȷ", "", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void button13_Click(object sender, EventArgs e) //
        {
            Program.config = ConfigManager.LoadConfig();
            string DbPath = Program.config.DatabaseFilePath;
            string keyword = textBox6.Text.Trim().ToUpper();
            string? selectedText = comboBox1.SelectedItem.ToString();
            if (selectedText == "Auto")
            {
                if (keyword.StartsWith("RJ"))
                {
                    selectedText = "H_RJ";
                }
                else if (keyword.StartsWith("D"))
                {
                    selectedText = "H_D";
                }
                else if (keyword.StartsWith("VJ"))
                {
                    selectedText = "H_VJ";
                }
                else
                {
                    Logp1("޷Զ");
                    return;
                }
            }
            bool Feature_Auto_Clear = checkBox6.Checked; //ӺԶ
            string connectionString = $"Data Source={DbPath};Version=3"; // SQLiteݿַ
            using (SQLiteConnection connection = new SQLiteConnection(connectionString))
            {
                connection.Open();
                if (label12.Text == "")
                {
                    // ʼӼ¼
                    string number = string.Empty;
                    foreach (char c in keyword)
                    {
                        if (char.IsDigit(c))
                        {
                            number += c;
                        }
                        else if (number.Length > 0)
                        {
                            // Ѿȡֲַֹ֣ͣȡ
                            break;
                        }
                    }

                    if (int.TryParse(number, out int asmr_order_id))
                    {
                        using (SQLiteCommand addCommand = new SQLiteCommand($"INSERT INTO {selectedText} (asmr_id, asmr_order_id) VALUES (@asmr_id, @asmr_order_id)", connection))
                        {
                            addCommand.Parameters.AddWithValue("@asmr_id", keyword);
                            addCommand.Parameters.AddWithValue("@asmr_order_id", asmr_order_id);
                            addCommand.ExecuteNonQuery();

                            // ӳɹ߼
                            label12.Text = "ɹ";
                            Logp1($"{keyword} ѳɹӵ {selectedText} ");
                            if (Feature_Auto_Clear)
                            {
                                textBox6.Text = string.Empty;
                            }
                        }
                    }
                    else
                    {
                        // ޷ȡֲֵ
                        Logp1("޷ȡֲ֣ʧ");
                    }

                }
                connection.Close();
            }

        }

        private void button12_Click(object sender, EventArgs e) //P1
        {
            //ǰ
            //֤ݿļǷȷ
            Program.config = ConfigManager.LoadConfig();
            string DbPath = Program.config.DatabaseFilePath;
            if (!File.Exists(DbPath))
            {
                Logp1("DBļ·ȼļ");
                return;
            }
            //ȡ/ӹؼʣǷϹ
            string keyword = textBox6.Text.Trim();
            string pattern = "^(RJ|VJ|D)[0-9]+$"; // ƥRJVJDͷֵģʽ

            if (Regex.IsMatch(keyword, pattern))
            {
                keyword = keyword.ToUpper(); // ؼתΪд
            }
            else
            {
                Logp1("ݸʽʽǷȷ");
                return;
            }
            //ȡѡ
            //֧Auto,H_RJ,H_D,H_VJ,NonH_RJ
            //Auto֧NonH_RJ
            object selectedValue = comboBox1.SelectedItem;
            string? selectedText;
            if (selectedValue != null)
            {
                selectedText = selectedValue.ToString();
                switch (selectedText)
                {
                    case "H_RJ":
                    case "NonH_RJ":
                        if (System.Text.RegularExpressions.Regex.IsMatch(keyword, @"^RJ\d+$"))
                        {
                            // RJ +  
                            break;
                        }
                        Logp1("ѡƥ");
                        return;
                    case "Auto": // Auto Detect Type
                        if (keyword.StartsWith("RJ"))
                        {
                            selectedText = "H_RJ";
                        }
                        else if (keyword.StartsWith("D"))
                        {
                            selectedText = "H_D";
                        }
                        else if (keyword.StartsWith("VJ"))
                        {
                            selectedText = "H_VJ";
                        }
                        else
                        {
                            Logp1("޷Զ");
                            return;
                        }
                        break;
                    case "H_D":
                        if (System.Text.RegularExpressions.Regex.IsMatch(keyword, @"^D\d+$"))
                        {
                            // D +  
                            break;
                        }
                        Logp1("ѡƥ");
                        return;

                    case "H_VJ":
                        if (System.Text.RegularExpressions.Regex.IsMatch(keyword, @"^VJ\d+$"))
                        {
                            // VJ +  
                            break;
                        }
                        Logp1("ѡƥ");
                        return;

                    default:
                        Logp1("쳣");
                        return;

                }
            }
            else
            {
                Logp1("δѡѡ");
                return;
            }
            //ȡѡֵ
            bool Feature_Auto_Add = checkBox5.Checked; //ҺȱʱԶ
            bool Feature_Auto_Clear = checkBox6.Checked; //ӺԶ
            //bool Feature_Auto_Detect_Type = checkBox7.Checked; //Զ //ƶ
            bool Feature_Auto_Backup = checkBox8.Checked; //Զݿ
                                                          //ִбݣҪ
            if (Feature_Auto_Backup)
            {
                // Ŀ¼
                string backupDir = Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "backup");
                if (!Directory.Exists(backupDir))
                {
                    Directory.CreateDirectory(backupDir);
                }

                // 챸ļʹʱΪļ
                string backupFileName = DateTime.Now.ToString("yyyyMMdd") + ".7z";
                string backupFilePath = Path.Combine(backupDir, backupFileName);
                // 鱸ǷѴ
                if (!File.Exists(backupFilePath))
                {
                    string sevenZipPath;

                    // жϵͳλ
                    if (Environment.Is64BitOperatingSystem)
                    {
                        sevenZipPath = Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "x64", "7za.exe");
                    }
                    else
                    {
                        sevenZipPath = Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "7za.exe");
                    }

                    if (!File.Exists(sevenZipPath))
                    {
                        Logp1("󣬶ʧ7za.exeļ");
                        return;
                    }


                    // ִб
                    ProcessStartInfo processInfo = new ProcessStartInfo();
                    processInfo.FileName = sevenZipPath; // 7-ZipĿִļ·
                    processInfo.Arguments = $"a -mx9 \"{backupFilePath}\" \"{DbPath}\""; // ִ7zѹ

                    Process process = new Process();
                    process.StartInfo = processInfo;
                    process.Start();
                    process.WaitForExit();

                    // 鱸Ƿɹ
                    if (File.Exists(backupFilePath))
                    {
                        Logp1($"Զݳɹݿѱ{backupFilePath}");
                    }
                    else
                    {
                        Logp1("ʧܣ");
                        return;
                    }
                }
                else
                {
                    Logp1("ѱ");
                }
            }

            //ʼ(selectedTextѡҪѯݱѯkeywordǷֶ"ID"
            //string DbPath = Program.config.DatabaseFilePath;
            //keyword
            //selectedTextH_RJ,H_D,H_VJ,NonH_RJ
            //ӦH_RJ,H_D,H_VJ,NonH_RJ
            QueryDB(DbPath, keyword, selectedText, Feature_Auto_Add, Feature_Auto_Clear);
        }

        private void QueryDB(string DbPath, string keyword, string selectedText, bool Feature_Auto_Add, bool Feature_Auto_Clear)
        {
            string connectionString = $"Data Source={DbPath};Version=3"; // SQLiteݿַ
            using (SQLiteConnection connection = new SQLiteConnection(connectionString))
            {
                connection.Open();

                using (SQLiteCommand command = new SQLiteCommand($"SELECT COUNT(*) FROM {selectedText} WHERE asmr_id = @keyword", connection))
                {
                    command.Parameters.AddWithValue("@keyword", keyword);

                    int count = Convert.ToInt32(command.ExecuteScalar());
                    button13.Enabled = false;
                    if (count == 1)
                    {
                        label12.Text = "Ѵ";
                        Logp1($"{keyword}Ѵ");
                    }
                    else if (count <= 0)
                    {
                        label12.Text = "";
                        button13.Enabled = true;
                        Logp1($"{keyword}");
                    }
                    else
                    {
                        label12.Text = "Ѵظ";
                        Logp1($"쳣{keyword}");
                    }
                }
                if (Feature_Auto_Add && label12.Text == "")
                {
                    // ʼӼ¼
                    string number = string.Empty;
                    foreach (char c in keyword)
                    {
                        if (char.IsDigit(c))
                        {
                            number += c;
                        }
                        else if (number.Length > 0)
                        {
                            // Ѿȡֲַֹ֣ͣȡ
                            break;
                        }
                    }

                    if (int.TryParse(number, out int asmr_order_id))
                    {
                        using (SQLiteCommand addCommand = new SQLiteCommand($"INSERT INTO {selectedText} (asmr_id, asmr_order_id) VALUES (@asmr_id, @asmr_order_id)", connection))
                        {
                            addCommand.Parameters.AddWithValue("@asmr_id", keyword);
                            addCommand.Parameters.AddWithValue("@asmr_order_id", asmr_order_id);
                            addCommand.ExecuteNonQuery();

                            // ӳɹ߼
                            label12.Text = "ɹ";
                            Logp1($"{keyword} ѳɹӵ {selectedText} ");
                            if (Feature_Auto_Clear)
                            {
                                textBox6.Text = string.Empty;
                            }
                        }
                    }
                    else
                    {
                        // ޷ȡֲֵ
                        Logp1("޷ȡֲ֣ʧ");
                    }

                }
                connection.Close();
            }
        }

        private void button17_Click(object sender, EventArgs e) //P3 ȡϢ
        {
            string driveLetter = textBox7.Text.Trim().ToUpper(); // ȡû̷תΪд
            string drivePath = $"{driveLetter}:\\"; // ϳ̷·

            string filePath = Path.Combine(drivePath, "asmr_storage.txt"); // ·

            if (File.Exists(filePath))
            {
                Logp3("ʶҵʼȡϢ");
            }
            else
            {
                Logp3("ָ·δҵʶ޷һ");
                return;
            }

            string folderPath = Path.Combine(drivePath, "H");
            string folderPath2 = Path.Combine(drivePath, "Non-H");

            // ȡָļµĿ¼
            string[] directories = Directory.GetDirectories(folderPath);
            string[] directories2 = Directory.GetDirectories(folderPath2);

            // List治ͬǰ׺Ŀ¼
            List<string> rjDirectories = new List<string>();
            List<string> dDirectories = new List<string>();
            List<string> vjDirectories = new List<string>();
            List<string> nonhrjDirectories = new List<string>();

            // Ŀ¼ǰ׺ӵӦList
            foreach (string directory in directories)
            {
                string directoryName = Path.GetFileName(directory);
                if (directoryName.EndsWith(".fin") || directoryName.EndsWith(".now"))
                {
                    directoryName = directoryName.Substring(0, directoryName.Length - 4);
                }

                if (directoryName.StartsWith("RJ", StringComparison.OrdinalIgnoreCase))
                {
                    rjDirectories.Add(directoryName);
                }
                else if (directoryName.StartsWith("D", StringComparison.OrdinalIgnoreCase))
                {
                    dDirectories.Add(directoryName);
                }
                else if (directoryName.StartsWith("VJ", StringComparison.OrdinalIgnoreCase))
                {
                    vjDirectories.Add(directoryName);
                }
            }
            foreach (string directory in directories2)
            {
                string directoryName = Path.GetFileName(directory);
                if (directoryName.EndsWith(".fin") || directoryName.EndsWith(".now"))
                {
                    directoryName = directoryName.Substring(0, directoryName.Length - 4);
                }
                if (directoryName.StartsWith("RJ", StringComparison.OrdinalIgnoreCase))
                {
                    nonhrjDirectories.Add(directoryName);
                }
            }
            label18.Text = rjDirectories.Count.ToString();
            label19.Text = dDirectories.Count.ToString();
            label20.Text = vjDirectories.Count.ToString();
            label21.Text = nonhrjDirectories.Count.ToString();

            Program.config ??= ConfigManager.LoadConfig();
            string connectionString = $"Data Source={Program.config.DatabaseFilePath};Version=3"; // SQLiteݿַ

            // List治ͬ͵
            List<string> rjData = new List<string>();
            List<string> dData = new List<string>();
            List<string> vjData = new List<string>();
            List<string> nonhrjData = new List<string>();

            // SQLiteݿ
            using (SQLiteConnection connection = new SQLiteConnection(connectionString))
            {
                connection.Open();

                // ȡH_RJе
                using (SQLiteCommand command = new SQLiteCommand("SELECT asmr_id FROM H_RJ", connection))
                using (SQLiteDataReader reader = command.ExecuteReader())
                {
                    while (reader.Read())
                    {
                        string asmrName = reader.GetString(0);
                        rjData.Add(asmrName);
                    }
                }

                // ȡH_Dе
                using (SQLiteCommand command = new SQLiteCommand("SELECT asmr_id FROM H_D", connection))
                using (SQLiteDataReader reader = command.ExecuteReader())
                {
                    while (reader.Read())
                    {
                        string asmrName = reader.GetString(0);
                        dData.Add(asmrName);
                    }
                }

                // ȡH_VJе
                using (SQLiteCommand command = new SQLiteCommand("SELECT asmr_id FROM H_VJ", connection))
                using (SQLiteDataReader reader = command.ExecuteReader())
                {
                    while (reader.Read())
                    {
                        string asmrName = reader.GetString(0);
                        vjData.Add(asmrName);
                    }
                }

                // ȡNonH_RJе
                using (SQLiteCommand command = new SQLiteCommand("SELECT asmr_id FROM NonH_RJ", connection))
                using (SQLiteDataReader reader = command.ExecuteReader())
                {
                    while (reader.Read())
                    {
                        string asmrName = reader.GetString(0);
                        nonhrjData.Add(asmrName);
                    }
                }

                connection.Close();
            }
            label26.Text = rjData.Count.ToString();
            label27.Text = dData.Count.ToString();
            label28.Text = vjData.Count.ToString();
            label29.Text = nonhrjData.Count.ToString();

            SaveDataP3(rjDirectories, dDirectories, vjDirectories, nonhrjDirectories, rjData, dData, vjData, nonhrjData);
            Logp3("ȡ");

        }

        private static void SaveDataP3(List<string> rjDirectories, List<string> dDirectories, List<string> vjDirectories, List<string> nonhrjDirectories, List<string> rjData, List<string> dData, List<string> vjData, List<string> nonhrjData) //ȡ񣬱ȡԺڱȽ
        {
            NaturalOrderComparer comparer = new NaturalOrderComparer();
            rjDirectories.Sort(comparer);
            dDirectories.Sort(comparer);
            vjDirectories.Sort(comparer);
            nonhrjDirectories.Sort(comparer);
            rjData.Sort(comparer);
            dData.Sort(comparer);
            vjData.Sort(comparer);
            nonhrjData.Sort(comparer);
            Program.data ??= new AsmrData();
            Program.data.file_rj_str = string.Join(Environment.NewLine, rjDirectories);
            Program.data.file_d_str = string.Join(Environment.NewLine, dDirectories);
            Program.data.file_vj_str = string.Join(Environment.NewLine, vjDirectories);
            Program.data.file_nonhrj_str = string.Join(Environment.NewLine, nonhrjDirectories);
            Program.data.db_rj_str = string.Join(Environment.NewLine, rjData);
            Program.data.db_d_str = string.Join(Environment.NewLine, dData);
            Program.data.db_vj_str = string.Join(Environment.NewLine, vjData);
            Program.data.db_nonhrj_str = string.Join(Environment.NewLine, nonhrjData);
        }

        private void Logp3(string message) //p3 log function
        {
            richTextBox2.AppendText(message + Environment.NewLine);
            richTextBox2.ScrollToCaret();
        }
        private void Logp1(string message) //p1 log function
        {
            richTextBox1.AppendText(message + Environment.NewLine);
            richTextBox1.ScrollToCaret();
        }

        private void button18_Click(object sender, EventArgs e) //p3Ƚ
        {
            Program.data ??= new AsmrData();
            if (checkBox9.Checked)
            {
                Logp3("# H_RJ:");
                DiffContent(Program.data.file_rj_str, Program.data.db_rj_str);
            }
            if (checkBox10.Checked)
            {
                Logp3("# H_D:");
                DiffContent(Program.data.file_d_str, Program.data.db_d_str);
            }
            if (checkBox11.Checked)
            {
                Logp3("# H_VJ:");
                DiffContent(Program.data.file_vj_str, Program.data.db_vj_str);
            }
            if (checkBox12.Checked)
            {
                Logp3("# NonH_RJ:");
                DiffContent(Program.data.file_nonhrj_str, Program.data.db_nonhrj_str);
            }

        }

        private void DiffContent(string before, string after) //ݱȽϣϸڲ
        {
            var diff_rj = InlineDiffBuilder.Diff(before, after);
            foreach (var line in diff_rj.Lines)
            {
                switch (line.Type)
                {
                    case ChangeType.Inserted:
                        Logp3("+ " + line.Text);
                        break;
                    case ChangeType.Deleted:
                        Logp3("- " + line.Text);
                        break;
                }
            }
        }

        private void button15_Click(object sender, EventArgs e) //save p3 log
        {
            SaveFileDialog saveFileDialog = new SaveFileDialog();
            saveFileDialog.Filter = "Log Files|*.log";
            saveFileDialog.Title = "Save Log File";
            saveFileDialog.FileName = DateTime.Now.ToString("yyyy-MM-dd") + ".log";

            if (saveFileDialog.ShowDialog() == DialogResult.OK)
            {
                string filePath = saveFileDialog.FileName;

                try
                {
                    using (StreamWriter writer = new StreamWriter(filePath))
                    {
                        writer.Write(richTextBox2.Text);
                    }

                    MessageBox.Show("־ѳɹ档", "ʾ", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
                catch (Exception ex)
                {
                    MessageBox.Show("־ʱ" + ex.Message, "", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
        }

        private void button16_Click(object sender, EventArgs e) //p3־
        {
            richTextBox2.Text = string.Empty;
        }

        private void button14_Click(object sender, EventArgs e) //p1־
        {
            textBox6.Text = string.Empty;
            richTextBox2.Text = string.Empty;
        }

        private void textBox6_TextChanged(object sender, EventArgs e) //keywordıʱ
        {
            button13.Enabled = false;
            label12.Text = string.Empty;
        }
    }
}